<?php

namespace DynamicContentForElementor\Widgets;

use Elementor\Controls_Manager;
use DynamicContentForElementor\Helper;
use DynamicContentForElementor\Includes\Skins;
if (!\defined('ABSPATH')) {
    exit;
    // Exit if accessed directly
}
class WooProductVariations extends \DynamicContentForElementor\Widgets\DynamicWooProducts
{
    public function get_name()
    {
        return 'dce-woo-products-variations';
    }
    /**
     * Register the skins for this function.
     *
     * @return void
     */
    protected function register_skins()
    {
        $this->add_skin(new Skins\SkinGrid($this));
        $this->add_skin(new Skins\SkinGridFilters($this));
        $this->add_skin(new Skins\SkinCarousel($this));
        $this->add_skin(new Skins\SkinDualCarousel($this));
        $this->add_skin(new Skins\SkinAccordion($this));
        $this->add_skin(new Skins\SkinList($this));
        $this->add_skin(new Skins\SkinTable($this));
    }
    /**
     * Register controls after check if this feature is only for admin
     *
     * @return void
     */
    protected function safe_register_controls()
    {
        parent::safe_register_controls();
        $this->update_control('query_type', ['type' => Controls_Manager::HIDDEN, 'default' => 'product_variations']);
        $this->update_control('post_type', ['type' => Controls_Manager::HIDDEN, 'default' => ['product_variations']]);
        $this->update_control('exclude_posts', ['type' => Controls_Manager::HIDDEN]);
    }
}
