<?php

namespace DynamicContentForElementor\Core\Upgrade;

use DynamicContentForElementor\Extensions;
if (!\defined('ABSPATH')) {
    exit;
    // Exit if accessed directly.
}
class UpgradesData
{
    const FEATURES_STATUS_2_4_4 = ['ext_animations' => 'active', 'ext_copypaste' => 'active', 'ext_editor' => 'active', 'ext_masking' => 'active', 'ext_rellax' => 'active', 'ext_reveal' => 'active', 'ext_tag_cryptocurrency' => 'active', 'ext_tag_favorites' => 'active', 'ext_tag_wishlist' => 'active', 'ext_template' => 'active', 'ext_token' => 'active', 'dynamic_tag_php' => 'active', 'ext_transforms' => 'active', 'ext_unwrap' => 'active', 'ext_video' => 'active', 'ext_visibility' => 'active', 'ext_form_address_autocomplete' => 'active', 'ext_form_amount' => 'active', 'ext_form_range' => 'active', 'ext_form_description' => 'active', 'ext_form_email' => 'active', 'ext_form_export' => 'active', 'ext_form_icons' => 'active', 'ext_form_inline_align' => 'active', 'ext_form_length' => 'active', 'ext_form_message' => 'active', 'ext_form_method' => 'active', 'ext_form_password_visibility' => 'active', 'ext_form_unique_id' => 'active', 'ext_form_counter' => 'active', 'ext_form_pdf' => 'active', 'ext_form_redirect' => 'active', 'ext_form_regex' => 'active', 'ext_form_reset' => 'active', 'ext_form_save' => 'active', 'ext_form_select2' => 'active', 'ext_form_signature' => 'active', 'ext_form_step' => 'active', 'ext_form_submit_on_change' => 'active', 'ext_form_submit' => 'active', 'ext_form_telegram' => 'active', 'ext_form_visibility' => 'inactive', 'ext_conditional_fields_v2' => 'active', 'ext_form_wysiwyg' => 'active', 'ext_form_paypal' => 'active', 'ext_form_stripe' => 'active', 'ext_custom_validation' => 'active', 'ext_js_field' => 'active', 'ext_live_html' => 'active', 'ext_hidden_label' => 'active', 'ext_dynamic_select' => 'active', 'ext_tooltip' => 'active', 'ext_dynamic_countdown' => 'active', 'ext_confirm_dialog' => 'active', 'wdg_acf' => 'active', 'wdg_gallery' => 'active', 'wdg_relationship' => 'active', 'wdg_repeater' => 'inactive', 'wdg_acf_repeater_v2' => 'active', 'wdg_acf_flexible_content' => 'active', 'wdg_slider' => 'active', 'wdg_barcode' => 'active', 'wdg_calendar' => 'active', 'wdg_clipboard' => 'active', 'wdg_dyncookie' => 'active', 'wdg_favorites' => 'active', 'wdg_wishlist' => 'active', 'wdg_modal_window' => 'active', 'wdg_pdf' => 'active', 'wdg_popup' => 'active', 'wdg_charts' => 'active', 'wdg_template' => 'active', 'wdg_tokens' => 'active', 'wdg_animate_text' => 'active', 'wdg_parallax' => 'active', 'wdg_threesixty_slider' => 'active', 'wdg_tilt' => 'active', 'wdg_twentytwenty' => 'active', 'wdg_doshortcode' => 'active', 'wdg_includefile' => 'active', 'wdg_rawphp' => 'active', 'wdg_remotecontent' => 'active', 'wdg_iframe' => 'active', 'wdg_google_doc_preview' => 'active', 'wdg_dynamicposts' => 'inactive', 'wdg_dynamicposts_v2' => 'active', 'wdg_dynamic_woo_products' => 'active', 'wdg_dynamic_woo_products_on_sale' => 'active', 'wdg_woo_products_cart' => 'active', 'wdg_woo_product_upsells' => 'active', 'wdg_woo_product_crosssells' => 'active', 'wdg_show_favorites' => 'active', 'wdg_show_wishlist' => 'active', 'wdg_stick_yposts' => 'active', 'wdg_search_results' => 'active', 'wdg_my_posts' => 'active', 'wdg_google_maps' => 'active', 'wdg_dynamic_users' => 'active', 'wdg_animated_offcanvas_menu' => 'active', 'wdg_cursor_tracker' => 'active', 'wdg_file_browser' => 'active', 'wdg_parent_child_menu' => 'active', 'wdg_search_filter' => 'active', 'wdg_single_posts_menu' => 'active', 'wdg_taxonomy_terms_menu' => 'active', 'wdg_views' => 'active', 'wdg_pods' => 'active', 'wdg_pods_gallery' => 'active', 'wdg_pods_relationship' => 'active', 'wdg_breadcrumbs' => 'active', 'wdg_content' => 'active', 'wdg_date' => 'active', 'wdg_excerpt' => 'active', 'wdg_featured_image' => 'active', 'wdg_icon_format' => 'active', 'wdg_meta' => 'active', 'wdg_next_prev' => 'active', 'wdg_read_more' => 'active', 'wdg_terms' => 'active', 'wdg_title' => 'active', 'wdg_title_type' => 'active', 'wdg_user' => 'active', 'wdg_title_taxonomy' => 'active', 'wdg_svg_blob' => 'active', 'wdg_svg_distortion' => 'active', 'wdg_svg_filter_effects' => 'active', 'wdg_svg_imagemask' => 'active', 'wdg_svg_morphing' => 'active', 'wdg_svg_path_text' => 'active', 'wdg_toolset' => 'active', 'wdg_toolset_relationship' => 'active', 'wdg_bg_canvas' => 'active', 'wdg_distortion_image' => 'active', 'wdg_panorama' => 'active', 'wdg_osm_map' => 'active', 'wdg_cryptocoin_badge' => 'active', 'wdg_pdf_viewer' => 'active', 'pst_scrolling' => 'active', 'gst_smooth_transition' => 'inactive', 'gst_tracker_header' => 'active'];
    const EXTENSION_TRANSLATION = ['DCE_Extension_Animations' => 'ext_animations', 'DCE_Extension_CopyPaste' => 'ext_copypaste', 'DCE_Extension_Editor' => 'ext_editor', 'DCE_Extension_Masking' => 'ext_masking', 'DCE_Extension_Rellax' => 'ext_rellax', 'DCE_Extension_Reveal' => 'ext_reveal', 'DCE_Extension_Template' => 'ext_template', 'DCE_Extension_Token' => 'ext_token', 'DCE_Extension_Php' => 'dynamic_tag_php', 'DCE_Extension_Transforms' => 'ext_transforms', 'DCE_Extension_Unwrap' => 'ext_unwrap', 'DCE_Extension_Video' => 'ext_video', 'DCE_Extension_Visibility' => 'ext_visibility', 'DCE_Extension_Form_Address_Autocomplete' => 'ext_form_address_autocomplete', 'DCE_Extension_Form_Amount' => 'ext_form_amount', 'DCE_Extension_Form_description' => 'ext_form_description', 'DCE_Extension_Form_Email' => 'ext_form_email', 'DCE_Extension_Form_Export' => 'ext_form_export', 'DCE_Extension_Form_Icons' => 'ext_form_icons', 'DCE_Extension_Form_Inline_Align' => 'ext_form_inline_align', 'DCE_Extension_Form_Length' => 'ext_form_length', 'DCE_Extension_Form_Message' => 'ext_form_message', 'DCE_Extension_Form_Method' => 'ext_form_method', 'DCE_Extension_Form_Password_Visibility' => 'ext_form_password_visibility', 'DCE_Extension_Form_PDF' => 'ext_form_pdf', 'DCE_Extension_Form_Redirect' => 'ext_form_redirect', 'DCE_Extension_Form_Regex' => 'ext_form_regex', 'DCE_Extension_Form_Reset' => 'ext_form_reset', 'DCE_Extension_Form_Save' => 'ext_form_save', 'DCE_Extension_Form_Select2' => 'ext_form_select2', 'DCE_Extension_Form_Signature' => 'ext_form_signature', 'DCE_Extension_Form_Step' => 'ext_form_step', 'DCE_Extension_Form_Submit_On_Change' => 'ext_form_submit_on_change', 'DCE_Extension_Form_Submit' => 'ext_form_submit', 'DCE_Extension_Form_Telegram' => 'ext_form_telegram', 'DCE_Extension_Form_Visibility' => 'ext_form_visibility', 'ConditionalFieldsV2' => 'ext_conditional_fields_v2', 'DCE_Extension_Form_WYSIWYG' => 'ext_form_wysiwyg', 'DCE_Extension_Form_PayPal' => 'ext_form_paypal', 'DCE_Extension_Form_Stripe' => 'ext_form_stripe', 'CustomValidation' => 'ext_custom_validation', 'JsField' => 'ext_js_field', 'LiveHtml' => 'ext_live_html', 'HiddenLabel' => 'ext_hidden_label', 'DynamicSelect' => 'ext_dynamic_select', 'Tooltip' => 'ext_tooltip', 'DynamicCountdown' => 'ext_dynamic_countdown', 'ConfirmDialog' => 'ext_confirm_dialog'];
    const WIDGET_TRANSLATION = ['DCE_Widget_Acf' => 'wdg_acf', 'DCE_Widget_Gallery' => 'wdg_gallery', 'DCE_Widget_Relationship' => 'wdg_relationship', 'DCE_Widget_Repeater' => 'wdg_repeater', 'Acf_Repeater_V2' => 'wdg_acf_repeater_v2', 'Acf_Flexible_Content' => 'wdg_acf_flexible_content', 'DCE_Widget_Slider' => 'wdg_slider', 'DCE_Widget_BarCode' => 'wdg_barcode', 'DCE_Widget_Calendar' => 'wdg_calendar', 'DCE_Widget_Clipboard' => 'wdg_clipboard', 'DCE_Widget_DynamicCookie' => 'wdg_dyncookie', 'DCE_Widget_Favorites' => 'wdg_favorites', 'DCE_Widget_ModalWindow' => 'wdg_modal_window', 'DCE_Widget_Pdf' => 'wdg_pdf', 'DCE_Widget_PopUp' => 'wdg_popup', 'DCE_Widget_Template' => 'wdg_template', 'DCE_Widget_Tokens' => 'wdg_tokens', 'DCE_Widget_AnimateText' => 'wdg_animate_text', 'DCE_Widget_Parallax' => 'wdg_parallax', 'DCE_Widget_ThreesixtySlider' => 'wdg_threesixty_slider', 'DCE_Widget_Tilt' => 'wdg_tilt', 'DCE_Widget_TwentyTwenty' => 'wdg_twentytwenty', 'DCE_Widget_DoShortcode' => 'wdg_doshortcode', 'DCE_Widget_IncludeFile' => 'wdg_includefile', 'DCE_Widget_RawPhp' => 'wdg_rawphp', 'DCE_Widget_RemoteContent' => 'wdg_remotecontent', 'Iframe' => 'wdg_iframe', 'GoogleDocumentPreview' => 'wdg_google_doc_preview', 'DCE_Widget_DynamicPosts' => 'wdg_dynamicposts', 'DCE_Widget_DynamicPosts_v2' => 'wdg_dynamicposts_v2', 'DynamicWooProducts' => 'wdg_dynamic_woo_products', 'WooProductsCart' => 'wdg_woo_products_cart', 'WooProductUpsells' => 'wdg_woo_product_upsells', 'WooProductCrosssells' => 'wdg_woo_product_crosssells', 'ShowFavorites' => 'wdg_show_favorites', 'StickyPosts' => 'wdg_stick_yposts', 'SearchResults' => 'wdg_search_results', 'MyPosts' => 'wdg_my_posts', 'DCE_Widget_GoogleMaps' => 'wdg_google_maps', 'DCE_Widget_DynamicUsers' => 'wdg_dynamic_users', 'DCE_Widget_AnimatedOffcanvasMenu' => 'wdg_animated_offcanvas_menu', 'DCE_Widget_CursorTracker' => 'wdg_cursor_tracker', 'DCE_Widget_FileBrowser' => 'wdg_file_browser', 'DCE_Widget_ParentChildMenu' => 'wdg_parent_child_menu', 'DCE_Widget_SearchFilter' => 'wdg_search_filter', 'DCE_Widget_SinglePostsMenu' => 'wdg_single_posts_menu', 'DCE_Widget_TaxonomyTermsMenu' => 'wdg_taxonomy_terms_menu', 'DCE_Widget_Views' => 'wdg_views', 'DCE_Widget_Pods' => 'wdg_pods', 'DCE_Widget_PodsGallery' => 'wdg_pods_gallery', 'DCE_Widget_PodsRelationship' => 'wdg_pods_relationship', 'DCE_Widget_Breadcrumbs' => 'wdg_breadcrumbs', 'DCE_Widget_Content' => 'wdg_content', 'DCE_Widget_Date' => 'wdg_date', 'DCE_Widget_Excerpt' => 'wdg_excerpt', 'DCE_Widget_FeaturedImage' => 'wdg_featured_image', 'DCE_Widget_IconFormat' => 'wdg_icon_format', 'DCE_Widget_Meta' => 'wdg_meta', 'DCE_Widget_NextPrev' => 'wdg_next_prev', 'DCE_Widget_ReadMore' => 'wdg_read_more', 'DCE_Widget_Terms' => 'wdg_terms', 'DCE_Widget_Title' => 'wdg_title', 'DCE_Widget_TitleType' => 'wdg_title_type', 'DCE_Widget_User' => 'wdg_user', 'DCE_Widget_TitleTaxonomy' => 'wdg_title_taxonomy', 'DCE_Widget_SvgBlob' => 'wdg_svg_blob', 'DCE_Widget_SvgDistortion' => 'wdg_svg_distortion', 'DCE_Widget_SvgFilterEffects' => 'wdg_svg_filter_effects', 'DCE_Widget_SvgImagemask' => 'wdg_svg_imagemask', 'DCE_Widget_SvgMorphing' => 'wdg_svg_morphing', 'DCE_Widget_Svg_PathText' => 'wdg_svg_path_text', 'DCE_Widget_Toolset' => 'wdg_toolset', 'DCE_Widget_ToolsetRelationship' => 'wdg_toolset_relationship', 'DCE_Widget_BgCanvas' => 'wdg_bg_canvas', 'DCE_Widget_DistortionImage' => 'wdg_distortion_image', 'DCE_Widget_Panorama' => 'wdg_panorama', 'OsmMap' => 'wdg_osm_map', 'PdfViewer' => 'wdg_pdf_viewer'];
    const SETTING_TRANSLATION = ['DCE_Document_Scrolling' => 'pst_scrolling', 'DCE_Settings_SmoothTransition' => 'gst_smooth_transition', 'DCE_Settings_TrackerHeader' => 'gst_tracker_header'];
}
